/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.wst.rdb.internal.core.rte;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.wst.rdb.internal.models.sql.schema.SQLObject;

public class DDLGeneratorWithCallbackWrapper implements DDLGeneratorWithCallback {
	private DDLGenerator ddlGenerator = null;
	
	public DDLGeneratorWithCallbackWrapper(DDLGenerator ddlGenerator) {
		this.ddlGenerator = ddlGenerator;
	}
	
	public String[] generateDDL(SQLObject[] elements, IProgressMonitor progressMonitor){
		return this.ddlGenerator.generateDDL(elements, progressMonitor);
	}
	
    public String[] createSQLObjects(SQLObject[] elements, boolean quoteIdentifiers, boolean qualifyNames, IProgressMonitor progressMonitor){
    	return this.ddlGenerator.generateDDL(elements, progressMonitor);
    }
    
    public String[] dropSQLObjects(SQLObject[] elements, boolean quoteIdentifiers, boolean qualifyNames, IProgressMonitor progressMonitor){
    	return this.ddlGenerator.dropSQLObjects(elements, quoteIdentifiers, qualifyNames, progressMonitor);
    }
	
	public EngineeringOption[] getOptions(){
		return this.ddlGenerator.getOptions();
	}

    public EngineeringOption[] getOptions(SQLObject[] elements){
    	return this.ddlGenerator.getOptions(elements);
    }
    
    public EngineeringOption[] getOptions(SQLObject[] elements, boolean autoDiscovery){
    	return this.ddlGenerator.getOptions(elements, autoDiscovery);
    }

    public EngineeringOptionCategory[] getOptionCategories(){
    	return this.ddlGenerator.getOptionCategories();
    }

    
    public String[] createSQLObjects(SQLObject[] elements, boolean quoteIdentifiers, boolean qualifyNames, IProgressMonitor progressMonitor,IEngineeringCallBack callback){
    	return this.ddlGenerator.createSQLObjects(elements, quoteIdentifiers, qualifyNames, progressMonitor);
    }
    
	public String[] generateDDL(SQLObject[] elements, IProgressMonitor progressMonitor,IEngineeringCallBack callback){
		return this.ddlGenerator.generateDDL(elements, progressMonitor);
	}
	
    public String[] dropSQLObjects(SQLObject[] elements, boolean quoteIdentifiers, boolean qualifyNames, IProgressMonitor progressMonitor,IEngineeringCallBack callback){
    	return this.ddlGenerator.dropSQLObjects(elements, quoteIdentifiers, qualifyNames, progressMonitor);
    }
	
}
